/*  Olimpo.h 1.3    Autor: Pedro Reina  */
#ifndef _OLIMPO_
#define _OLIMPO_
#define OLIMPO_PC
#pragma warn -eff
#include <stdio.h>     
#define NULO NULL
#define NIL  0
typedef unsigned char logico;
#define NO 0
#define SI 1
typedef unsigned char octeto;
typedef signed short int contador;
typedef signed long entero;
typedef unsigned long entpos;
typedef float real;
#define Abs(x)     ( ((x)>0) ? (x) : (-(x)) )
#define Min(x,y)   ( ((x)<(y)) ? (x) : (y) )
#define Max(x,y)   ( ((x)>(y)) ? (x) : (y) )
#include <conio.h>     
#include <dos.h>       
void   Pan_Resalta();
void   Pan_CursorVisible();
void   Pan_Bloque();
logico Pan_EntPos();
logico Pan_EntSig();
void Pan_BorraTex();
void Pan_CarGraf();
void Pan_TexGraf();
void Pan_RealGraf();
#define PAN_TEXTO    0
#define PAN_GRAFICO  1
#define PAN_MAXCOL   80
#define PAN_ANCHOCAR         8      
#define PAN_ALTOCAR         16      
#define PAN_MARGEN           3      
#define PAN_MARGENSUPERIOR  48      
#define PAN_MARGENIZQUIERDO  0      
#define NEGRO   0
#define ROJO    4
#define VERDE   2
#define BLANCO  7
extern contador Pan_Mod_;        
extern contador Pan_Fil_;        
extern contador Pan_Col_;        
extern contador Pan_Tin_;        
extern contador Pan_Pap_;        
extern logico   Pan_Resal_;      
extern char far *Pan_TabCar_;    
#define Pan_Modo()  Pan_Mod_
#define Pan_Limpia()  ( Pan_Mod_ ? ( Pan_Bloque(Pan_Pap_,0,0,29,79) , SI ) \
                                 : ( clrscr() , SI ) )
#define Pan_Tinta(c)  ( Pan_Mod_ ? ( Pan_Tin_=c , SI ) \
                                 : ( textcolor(c) , SI ) )
#define Pan_Papel(c)  ( Pan_Mod_ ? ( Pan_Pap_=c , SI ) \
                                 : ( textbackground(c) , SI ) )
#define Pan_Color(p,t)   ( Pan_Papel(p) , Pan_Tinta(t) )
#define Pan_Cursor(f,c)  ( Pan_Mod_ ? (Pan_Fil_=(f)+PAN_MARGEN,Pan_Col_=c,SI) \
                                    : ( gotoxy((c)+1,(f)+1) , SI ) )
#define Pan_BorraLinea(f)  ( Pan_Mod_ ? \
               (Pan_Bloque(Pan_Pap_,(f)+PAN_MARGEN,0,(f)+PAN_MARGEN,79),SI) \
             : ( gotoxy(1,(f)+1) , clreol() , SI ) )
#define Pan_Caracter(c)  ( Pan_Mod_ ? ( Pan_CarGraf(c) , SI ) \
                                    : ( putch(c) , SI ) )
#define Pan_PonCar(fil,col,car)  (Pan_Cursor(fil,col),Pan_Caracter(car))
#define Pan_Texto(t)  ( Pan_Mod_ ? ( Pan_TexGraf(t) , SI ) \
                                 : ( cputs(t) , SI ) )
#define Pan_PonTexto(fil,col,t)  (Pan_Cursor(fil,col),Pan_Texto(t))
#define Pan_Entero(e,a)  ( (e) > 0 ? Pan_EntPos((entpos)e,a) \
                                   : Pan_EntSig((entero)e,a) )
#define Pan_PonEntero(fil,col,e,a)  (Pan_Cursor(fil,col),Pan_Entero(e,a))
#define Pan_Real(r,a,d)  ( Pan_Mod_ ? ( Pan_RealGraf((real)r,a,d) , SI ) \
                                    : ( cprintf("%*.*f",a,d,(real)r) , SI ) )
#define Pan_PonReal(f,c,r,a,d)  ( Pan_Cursor(f,c), Pan_Real(r,a,d) )
#define Pan_Borra(c,f1,c1,f2,c2)  ( Pan_Mod_ ? \
                     (Pan_Bloque(c,(f1)+PAN_MARGEN,c1,(f2)+PAN_MARGEN,c2),SI) \
                   : (Pan_BorraTex(c,f1,c1,f2,c2),SI) )
#include <stdlib.h>         
#include <time.h>           
#define Azr_Inicia() srand(time(0))
#define Azr_Entero(a,b)  ((a)+(rand()%((b)-(a)+1)))
#include <bios.h>               
contador Tim_Ano();
contador Tim_Mes();
contador Tim_Dia();
contador Tim_Hora();
contador Tim_Minuto();
contador Tim_Segundo();
#define Tim_Crono()  ((real)(biostime(0,0L)/18.2))
#define Tim_Espera(s)    delay((real)s*1000)
typedef struct Lis_ST {
                      char          *Contenido;
                      struct Lis_ST *Siguiente;
                      } Lis_st, *lista;
lista  Lis_Crea();
lista  Lis_Agrega();
lista  Lis_AgregaFin();
entero Lis_Total();
void   Lis_Destruye();
#define Lis_Contenido(L)  ( (L) -> Contenido )
#define Lis_PonContenido(L,C)  ( (L)->Contenido = (C) )
#define Lis_Siguiente(L)  ( (L) -> Siguiente )
#define Lis_PonSiguiente(L,S)  ( (L)->Siguiente = (S) )
extern logico Son_Encendido;
logico Son_Ejecuta();
#define Son_Estado()  Son_Encendido
#define Son_Cambia()  (Son_Encendido=!Son_Encendido)
#define Son_Enciende()  (Son_Encendido = SI)
#define Son_Apaga()  (Son_Encendido = NO)
#define Son_Error()   Son_Ejecuta(100,1.0)
#define Son_MalaTecla()   Son_Ejecuta(50,0.1)
#define Son_Bien()   Son_Ejecuta(880,0.1)
typedef unsigned char caracter;
logico   Car_EsMayus();
logico   Car_EsMinus();
caracter Car_Mayus();
caracter Car_Minus();
caracter Car_Convierte();
contador Car_Compara();
#define CAR_QL 0
#define CAR_PC 1
#define CAR_A_AGUDO 160 
#define CAR_E_AGUDO 130 
#define CAR_I_AGUDO 161 
#define CAR_O_AGUDO 162 
#define CAR_U_AGUDO 163 
#define CAR_A_GRAVE  133
#define CAR_E_GRAVE  138
#define CAR_I_GRAVE  141
#define CAR_O_GRAVE  149
#define CAR_U_GRAVE  151
#define CAR_A_CIRCUNFLEJO  131
#define CAR_E_CIRCUNFLEJO  136
#define CAR_I_CIRCUNFLEJO  140
#define CAR_O_CIRCUNFLEJO  147
#define CAR_U_CIRCUNFLEJO  150
#define CAR_A_DIERESIS  132
#define CAR_E_DIERESIS  137
#define CAR_I_DIERESIS  139
#define CAR_O_DIERESIS  148
#define CAR_U_DIERESIS  129
#define CAR_MAY_A_DIERESIS  142
#define CAR_MAY_O_DIERESIS  153
#define CAR_MAY_U_DIERESIS  154
#define CAR_MAY_E_AGUDO 144
#define CAR_N_TILDE     164
#define CAR_MAY_N_TILDE 165
#define CAR_C_CEDILLA     135
#define CAR_MAY_C_CEDILLA 128 
#define CAR_ADMIRACION    173
#define CAR_INTERROGACION 168
#define CAR_AE     145
#define CAR_MAY_AE 146
#define CAR_ALFA  224
#define CAR_BETA  225
#define CAR_DELTA 235
#define CAR_FI    237
#define CAR_MU    230
#define CAR_PI    227
#define CAR_DIVISION 246
#define CAR_ANGSTROM 143
#define CAR_COMILLA_ABRIR  174
#define CAR_COMILLA_CERRAR 175
#define CAR_FINPARRAFO      21
#define CAR_LIBRA   156
#define CAR_CENTAVO 155
#define CAR_YEN     157
#define CAR_FLECHA_ARRIBA     24
#define CAR_FLECHA_ABAJO      25 
#define CAR_FLECHA_DERECHA    26
#define CAR_FLECHA_IZQUIERDA  27
typedef struct {
               contador MargenIzquierdo;   
               contador MargenSuperior;    
               contador AnchoFisico;       
               contador AltoFisico;        
               float    Ancho;             
               float    Alto;              
               float    OrigenX;           
               float    OrigenY;           
               contador FilSup;            
               contador FilInf;            
               contador ColIzq;            
               contador ColDer;            
               } zon_st, *zona;
zona   Zon_Crea();
zona   Zon_Escala();
logico Zon_PixelFisico();
logico Zon_OxelFisico();
#define Zon_MargenIzquierdo(z)  ((z)->MargenIzquierdo)
#define Zon_PonMargenIzquierdo(z,v)  ((z)->MargenIzquierdo=(v))
#define Zon_MargenSuperior(z)  ((z)->MargenSuperior)
#define Zon_PonMargenSuperior(z,v)  ((z)->MargenSuperior=(v))
#define Zon_AnchoFisico(z)  ((z)->AnchoFisico)
#define Zon_PonAnchoFisico(z,v)  ((z)->AnchoFisico=(v))
#define Zon_AltoFisico(z)  ((z)->AltoFisico)
#define Zon_PonAltoFisico(z,v)  ((z)->AltoFisico=(v))
#define Zon_Ancho(z)  ((z)->Ancho)
#define Zon_PonAncho(z,v)  ((z)->Ancho=(v))
#define Zon_Alto(z)  ((z)->Alto)
#define Zon_PonAlto(z,v)  ((z)->Alto=(v))
#define Zon_OrigenX(z)  ((z)->OrigenX)
#define Zon_PonOrigenX(z,v)  ((z)->OrigenX=(v))
#define Zon_OrigenY(z)  ((z)->OrigenY)
#define Zon_PonOrigenY(z,v)  ((z)->OrigenY=(v))
#define Zon_FilSup(z)  ((z)->FilSup)
#define Zon_PonFilSup(z,v)  ((z)->FilSup=(v))
#define Zon_FilInf(z)  ((z)->FilInf)
#define Zon_PonFilInf(z,v)  ((z)->FilInf=(v))
#define Zon_ColIzq(z)  ((z)->ColIzq)
#define Zon_PonColIzq(z,v)  ((z)->ColIzq=(v))
#define Zon_ColDer(z)  ((z)->ColDer)
#define Zon_PonColDer(z,v)  ((z)->ColDer=(v))
#define Zon_Borra(z,c)  (Pan_Borra(c,Zon_FilSup(z),Zon_ColIzq(z), \
                                     Zon_FilInf(z),Zon_ColDer(z)))
#define Zon_Destruye(z)  (free(z))
#define Zon_Pixel(z,x,y,c)  (Zon_PixelPertenece(z,x,y) ? \
                             Zon_PixelSeguro(z,x,y,c)  : \
                             NO )
#define Zon_PixelPertenece(z,x,y)  (0 <= (x) && (x) < Zon_AnchoFisico(z) && \
                                    0 <= (y) && (y) < Zon_AltoFisico(z))
#define Zon_PixelSeguro(z,x,y,c)  Zon_PixelFisico(Zon_MargenIzquierdo(z)+x, \
                                                  Zon_MargenSuperior(z)+y,c)
#define Zon_Oxel(z,x,y,m,c)  (Zon_OxelPertenece(z,x,y)  ? \
                              Zon_OxelSeguro(z,x,y,m,c) : \
                              NO )
#define Zon_OxelPertenece(z,x,y) (0 <= (x) && (x) < Zon_AnchoEnOxel(z) && \
                                  0 <= (y) && (y) < Zon_AltoFisico(z))
#define Zon_AnchoEnOxel(z)  (Zon_AnchoFisico(z)/PAN_ANCHOCAR)
#define Zon_OxelSeguro(z,x,y,m,c)  Zon_OxelFisico(Zon_ColIzq(z)+(x), \
                                                  Zon_MargenSuperior(z)+y,m,c)
#include <string.h>             
#include <stdarg.h>             
typedef caracter * cadena;
#define CAD_FIN  ((cadena)NIL)
cadena   Cad_Une (cadena C, ...);
cadena   Cad_Crea ();
cadena   Cad_Trozo ();
cadena   Cad_Cambia ();
cadena   Cad_Mueve ();
cadena   Cad_QuitaCar ();
cadena   Cad_Duplica ();
cadena   Cad_EntPos ();
cadena   Cad_EntSig ();
cadena   Cad_Mayus ();
cadena   Cad_Minus ();
cadena   Cad_Convierte ();
contador Cad_Subcadena ();
contador Cad_PrimerUtil ();
contador Cad_CarPertenece ();
contador Cad_Compara ();
#define Cad_Destruye(c)   free(c)
#define Cad_Copia(d,o)  ((cadena)strcpy((char *)d,(char *)o))
#define Cad_Longitud(c)  ((contador)strlen((char *)c))
#define Cad_Igual(c,d)  (!strcmp((char *)c,(char *)d))
#define Cad_Entero(n)  ( (n)>0 ? Cad_EntPos((entpos)(n)) \
                               : Cad_EntSig((entero)(n)) )
typedef unsigned short int tecla;
tecla  Tec_Pulsada();
tecla  Tec_Validada();
tecla  Tec_ValidadaRapido();
tecla  Tec_Pertenece();
logico Tec_FijadoMayus();
extern tecla Tec_Ultima_;
#define Tec_Ultima()   Tec_Ultima_
#define Tec_Mayus(t)   ( ((t)<256) ? ((tecla)Car_Mayus((caracter)(t))) : (t) )
#define Tec_Minus(t)   ( ((t)<256) ? ((tecla)Car_Minus((caracter)(t))) : (t) )
#define Tec_Disponible()  kbhit()
#define TEC_MIN    32
#define TEC_MAX   254
#define TEC_ESC           27    
#define TEC_ENTER         13    
#define TEC_ESPACIO       32    
#define TEC_ARRIBA         328  
#define TEC_ABAJO          336  
#define TEC_IZQUIERDA      331  
#define TEC_DERECHA        333  
#define TEC_INICIO         327  
#define TEC_FIN            335  
#define TEC_AVPAG          337  
#define TEC_REPAG          329  
#define TEC_CTRL_INICIO    375  
#define TEC_CTRL_FIN       373  
#define TEC_CTRL_AVPAG     374  
#define TEC_CTRL_REPAG     388  
#define TEC_INSERTAR       338  
#define TEC_SUPRIMIR       339  
#define TEC_RETROCESO      8    
#define TEC_TAB            9    
#define TEC_MAY_TAB        271  
#define TEC_A        97        
#define TEC_B        98        
#define TEC_C        99        
#define TEC_D       100        
#define TEC_E       101        
#define TEC_F       102        
#define TEC_G       103        
#define TEC_H       104        
#define TEC_I       105        
#define TEC_J       106        
#define TEC_K       107        
#define TEC_L       108        
#define TEC_M       109        
#define TEC_N       110        
#define TEC_O       111        
#define TEC_P       112        
#define TEC_Q       113        
#define TEC_R       114        
#define TEC_S       115        
#define TEC_T       116        
#define TEC_U       117        
#define TEC_V       118        
#define TEC_W       119        
#define TEC_X       120        
#define TEC_Y       121        
#define TEC_Z       122        
#define TEC_MAY_A    65        
#define TEC_MAY_B    66        
#define TEC_MAY_C    67        
#define TEC_MAY_D    68        
#define TEC_MAY_E    69        
#define TEC_MAY_F    70        
#define TEC_MAY_G    71        
#define TEC_MAY_H    72        
#define TEC_MAY_I    73        
#define TEC_MAY_J    74        
#define TEC_MAY_K    75        
#define TEC_MAY_L    76        
#define TEC_MAY_M    77        
#define TEC_MAY_N    78        
#define TEC_MAY_O    79        
#define TEC_MAY_P    80        
#define TEC_MAY_Q    81        
#define TEC_MAY_R    82        
#define TEC_MAY_S    83        
#define TEC_MAY_T    84        
#define TEC_MAY_U    85        
#define TEC_MAY_V    86        
#define TEC_MAY_W    87        
#define TEC_MAY_X    88        
#define TEC_MAY_Y    89        
#define TEC_MAY_Z    90        
#define TEC_0        48        
#define TEC_1        49        
#define TEC_2        50        
#define TEC_3        51        
#define TEC_4        52        
#define TEC_5        53        
#define TEC_6        54        
#define TEC_7        55        
#define TEC_8        56        
#define TEC_9        57        
#define TEC_CTRL_A        1     
#define TEC_CTRL_B        2     
#define TEC_CTRL_C        3     
#define TEC_CTRL_D        4     
#define TEC_CTRL_E        5     
#define TEC_CTRL_F        6     
#define TEC_CTRL_G        7     
#define TEC_CTRL_H        8     
#define TEC_CTRL_I        9     
#define TEC_CTRL_J        10    
#define TEC_CTRL_K        11    
#define TEC_CTRL_L        12    
#define TEC_CTRL_M        13    
#define TEC_CTRL_N        14    
#define TEC_CTRL_O        15    
#define TEC_CTRL_P        16    
#define TEC_CTRL_Q        17    
#define TEC_CTRL_R        18    
#define TEC_CTRL_S        19    
#define TEC_CTRL_T        20    
#define TEC_CTRL_U        21    
#define TEC_CTRL_V        22    
#define TEC_CTRL_W        23    
#define TEC_CTRL_X        24    
#define TEC_CTRL_Y        25    
#define TEC_CTRL_Z        26    
#define TEC_ALT_A         286   
#define TEC_ALT_B         304   
#define TEC_ALT_C         302   
#define TEC_ALT_D         288   
#define TEC_ALT_E         274   
#define TEC_ALT_F         289   
#define TEC_ALT_G         290   
#define TEC_ALT_H         291   
#define TEC_ALT_I         279   
#define TEC_ALT_J         292   
#define TEC_ALT_K         293   
#define TEC_ALT_L         294   
#define TEC_ALT_M         306   
#define TEC_ALT_N         305   
#define TEC_ALT_O         280   
#define TEC_ALT_P         281   
#define TEC_ALT_Q         272   
#define TEC_ALT_R         275   
#define TEC_ALT_S         287   
#define TEC_ALT_T         276   
#define TEC_ALT_U         278   
#define TEC_ALT_V         303   
#define TEC_ALT_W         273   
#define TEC_ALT_X         301   
#define TEC_ALT_Y         277   
#define TEC_ALT_Z         300   
#define TEC_ALT_0         385   
#define TEC_ALT_1         376   
#define TEC_ALT_2         377   
#define TEC_ALT_3         378   
#define TEC_ALT_4         379   
#define TEC_ALT_5         380   
#define TEC_ALT_6         381   
#define TEC_ALT_7         382   
#define TEC_ALT_8         383   
#define TEC_ALT_9         384   
#define TEC_F1            315   
#define TEC_F2            316   
#define TEC_F3            317   
#define TEC_F4            318   
#define TEC_F5            319   
#define TEC_MAY_F1        340   
#define TEC_MAY_F2        341   
#define TEC_MAY_F3        342   
#define TEC_MAY_F4        343   
#define TEC_MAY_F5        344   
#define TEC_CTRL_F1       350   
#define TEC_CTRL_F2       351   
#define TEC_CTRL_F3       352   
#define TEC_CTRL_F4       353   
#define TEC_ALT_F1        360   
#define TEC_ALT_F2        361   
#define TEC_ALT_F3        362   
#define TEC_ALT_F4        363   
#define TEC_ALT_F5        364   
#define CDR_SIMPLE  0
#define CDR_DOBLE   1
#define CDR_ARRIBA  0
#define CDR_CENTRO  1
#define CDR_CORTE   2
#define CDR_ABAJO   3
extern contador Cdr_Color_;
void   Cdr_Dibuja();
lista  Cdr_Construye();
void   Cdr_Linea();
cadena Cdr_LineaVariada();
#define Cdr_Caja(Tipo,F1,C1,F2,C2)  Cdr_Dibuja(Tipo,Tipo,\
                                    1,(F2)-(F1)-1,1,(C2)-(C1)-1,F1,C1)
#define Cdr_Color(Color)   (Cdr_Color_=(Color))
#define USR_MENSAJE 22
logico   Usr_Consulta();
void     Usr_BorraZona();
void     Usr_Informa();
void     Usr_Avisa();
void     Usr_Indica();
void     Usr_IndicaModo();
void     Usr_IndicaMayus();
contador Usr_Entero();
cadena   Usr_Texto();
#include <dir.h>                
typedef FILE *fichero;
logico  Fch_Existe();
fichero Fch_AbreLeer();
fichero Fch_AbreGrabar();
fichero Fch_AbreActualizar();
void    Fch_Borra();
cadena  Fch_LeeLinea();
fichero Fch_EscribeLinea();
fichero Fch_EscribeOcteto();
fichero Fch_LeeOcteto();
cadena  Fch_Nombre();
lista   Fch_ListaNombre();
void Fch_Inicia();
#define FCH_TEXTO      0
#define FCH_BINARIO    1
#define Fch_Abre(Nombre,Modo)  (Fch_Inicia(),fopen(Nombre,Modo))
#define Fch_Cierra(f)   fclose(f)
#define Fch_Coloca(f,p)   fseek(f,(long)p,SEEK_SET)
#define Fch_ColocaFinal(f)   fseek(f,0L,SEEK_END)
#define MEN_INDICADOR  '>'   
contador Men_Horizontal();
contador Men_Vertical();
contador Men_TotalOpcion();
char     Men_Examina();
void     Men_EscribeNormal();
void     Men_EscribeResaltado();
void     Men_EscribeCarResaltado();
void Prg_Presenta();
cadena Cnf_Lee();
#define Cnf_Abre(Nombre)  Fch_AbreLeer(Nombre,FCH_TEXTO)
#define Cnf_Cierra(f)  Fch_Cierra(f)
#define BDT_LECTURA       0
#define BDT_ACTUALIZACION 1
#define BDT_LONGDESCRIPTOR 32
typedef struct {
               fichero  Fichero;
               octeto   DescriptorFichero[BDT_LONGDESCRIPTOR];
               char    *DescriptoresCampo;
               char    *InfoActual;
               entero   Actual;
               contador TotalCampo;
               entero   TotalRegistro;
               logico   Modificado;
               char     ModoApertura;
               entero   ComienzoRegistro;
               contador LongitudRegistro;
               } bdt_st, *basedato;
basedato Bdt_CreaObjeto();
basedato Bdt_Abre();
void     Bdt_Cierra();
basedato Bdt_Crea();
void     Bdt_Destruye();
logico   Bdt_NombreDeCampo();
logico   Bdt_NumeroDeCampo();
logico   Bdt_LeeRegistro();
logico   Bdt_EscribeRegistro();
logico   Bdt_MarcaRegistro();
logico   Bdt_AgregaRegistro();
logico   Bdt_CampoNumero();
logico   Bdt_CampoNombre();
logico   Bdt_PonCampoNumero();
logico   Bdt_PonCampoNombre();
char     Bdt_TipoDeCampo();
contador Bdt_LongitudDeCampo();
contador Bdt_DecimalDeCampo();
#define Bdt_Fichero(b)  ((b)->Fichero)
#define Bdt_PonFichero(b,f)  (((b)->Fichero)=(f))
#define Bdt_DescriptorFichero(b)  ((b)->DescriptorFichero)
#define Bdt_DescriptoresCampo(b)  ((b)->DescriptoresCampo)
#define Bdt_PonDescriptoresCampo(b,d)  (((b)->DescriptoresCampo)=(d))
#define Bdt_InfoActual(b)  ((b)->InfoActual)
#define Bdt_PonInfoActual(b,d)  (((b)->InfoActual)=(d))
#define Bdt_Actual(b)  ((b)->Actual)
#define Bdt_PonActual(b,n)  (((b)->Actual)=(n))
#define Bdt_TotalCampo(b)  ((b)->TotalCampo)
#define Bdt_PonTotalCampo(b,n)  (((b)->TotalCampo)=(n))
#define Bdt_TotalRegistro(b)  ((b)->TotalRegistro)
#define Bdt_PonTotalRegistro(b,n)  (((b)->TotalRegistro)=(n))
#define Bdt_Modificado(b)  ((b)->Modificado)
#define Bdt_PonModificado(b,v)  (((b)->Modificado)=(v))
#define Bdt_ModoApertura(b)  ((b)->ModoApertura)
#define Bdt_PonModoApertura(b,m)  (((b)->ModoApertura)=(m))
#define Bdt_ComienzoRegistro(b)  ((b)->ComienzoRegistro)
#define Bdt_PonComienzoRegistro(b,n)  (((b)->ComienzoRegistro)=(n))
#define Bdt_LongitudRegistro(b)  ((b)->LongitudRegistro)
#define Bdt_PonLongitudRegistro(b,l)  (((b)->LongitudRegistro)=(l))
#define Bdt_AnoUltimo(b)  ((contador) (1900+Bdt_DescriptorFichero(b)[1]))
#define Bdt_PonAnoUltimo(b,a)  (Bdt_DescriptorFichero(b)[1]=(char)((a)-1900))
#define Bdt_MesUltimo(b)  ((contador) (Bdt_DescriptorFichero(b)[2]))
#define Bdt_PonMesUltimo(b,m)  (Bdt_DescriptorFichero(b)[2]=(char)(m))
#define Bdt_DiaUltimo(b)  ((contador) (Bdt_DescriptorFichero(b)[3]))
#define Bdt_PonDiaUltimo(b,d)  (Bdt_DescriptorFichero(b)[3]=(char)(d))
#define Bdt_ActivoRegistro(b)  (Bdt_InfoActual(b)[0]!='*')
#define Bdt_LimpiaRegistro(b)  (memset(Bdt_InfoActual(b),' ',  \
                                Bdt_LongitudRegistro(b)))
#define Bdt_BorraRegistro(b,n)  (Bdt_MarcaRegistro(b,n,'*'))
#define Bdt_RecuperaRegistro(b,n)  (Bdt_MarcaRegistro(b,n,' '))
#define IND_LECTURA       0
#define IND_ACTUALIZACION 1
#define IND_PAGINA        1024        
#define IND_MINNIVEL      10          
#define IND_FUERA         (-1)        
typedef struct {
               fichero   Fichero;              
               char      ModoApertura;        
               contador  LongitudClave;       
               octeto    Pagina[IND_PAGINA];   
               contador  Nivel;                
               contador  MaxNivel;        
               contador *DirItem;     
               entero   *DirPosicion; 
               } ind_st, *indice;
indice Ind_CreaObjeto();
indice Ind_Abre();
void   Ind_Cierra();
void   Ind_Destruye();
entero Ind_Registro();
entero Ind_PaginaApuntada();
logico Ind_LeePagina();
logico Ind_IncrementaNivel();
logico Ind_DecrementaNivel();
logico Ind_Primero();
logico Ind_Ultimo();
logico Ind_Siguiente();
cadena Ind_Clave();
#define Ind_Fichero(i)  ((i)->Fichero)
#define Ind_PonFichero(i,f)  (((i)->Fichero)=(f))
#define Ind_ModoApertura(i)  ((i)->ModoApertura)
#define Ind_PonModoApertura(i,m)  (((i)->ModoApertura)=(m))
#define Ind_LongitudClave(i)  ((i)->LongitudClave)
#define Ind_PonLongitudClave(i,l)  (((i)->LongitudClave)=(l))
#define Ind_Pagina(i)  ((i)->Pagina)
#define Ind_Nivel(i)  ((i)->Nivel)
#define Ind_PonNivel(i,n)  (((i)->Nivel)=(n))
#define Ind_MaxNivel(i)  ((i)->MaxNivel)
#define Ind_PonMaxNivel(i,n)  (((i)->MaxNivel)=(n))
#define Ind_DirItem(i)  ((i)->DirItem)
#define Ind_PonDirItem(i,d)  (((i)->DirItem)=(d))
#define Ind_DirPosicion(i)  ((i)->DirPosicion)
#define Ind_PonDirPosicion(i,d)  (((i)->DirPosicion)=(d))
#define Ind_Cierra(i)  (Fch_Cierra(Ind_Fichero(i)),Ind_Destruye(i))
#define Ind_MaxItem(i)  (Ind_Pagina(i)[0] + 256 * Ind_Pagina(i)[1])
#define Ind_Desplazamiento(i,n)  (Ind_Pagina(i)[2+2*(n)] + \
                                  256 * Ind_Pagina(i)[3+2*(n)])
#define Ind_Item(i)  (Ind_DirItem(i)[Ind_Nivel(i)])
#define Ind_PonItem(i,n)  ((Ind_DirItem(i)[Ind_Nivel(i)])=(n))
#define Ind_Posicion(i)  (Ind_DirPosicion(i)[Ind_Nivel(i)])
#define Ind_PonPosicion(i,d)  ((Ind_DirPosicion(i)[Ind_Nivel(i)])=(d))
#define Ind_IncrementaItem(i)  ((Ind_DirItem(i)[Ind_Nivel(i)])++)
#define Ind_DecrementaItem(i)  ((Ind_DirItem(i)[Ind_Nivel(i)])--)
#endif /* _OLIMPO_ */
